//*****************************************************************************
//      C++ functions for:
//		interpolation settings window
//
//      Written by Stuart Prescott:
//              Written:                24/10/1996
//              Last Modified:          27/10/1996
//
//      Libraries Required:
//              libsx (Dominic Giamapolo - Athena Widget Set)
//
//      Other Object Classes used:
//              main program data structure
//
//*****************************************************************************

//*****************************************************************************
// Hmmmmm. 
// Had some trouble with segmentation faults under linux with these functions
// - could pin them down to anything ( - they were intermittent, GDB (under
// linux) couldn't  backtrace the stack properly to help find the source, and
// they _don't_ occur on ugrad. grrrrr!
//
// Is this a linux problem? (or a problem with my setup of linux :-)? 
// or a stray pointer problem?
//
// All pointers appear to be accounted for & behaving
//
// footnote: if you press cancel and then try again it seems to behave under
// linux (reasonably)
//*****************************************************************************


extern "C" {
    #include <libsx.h>
}
#include "intwin.h"
#include "main.h"

//***************************************************************************  
//***************************************************************************  
IntWin::IntWin(MyProgram *AllData)
{
    // create a window to allow the interpolation level to be set

    win=MakeWindow("Interpolation Control", SAME_DISPLAY, EXCLUSIVE_WINDOW);

    label = MakeLabel(

"Set Interpolation Level or Cancel\n\n
Note: lower pixel values will take longer\n
to draw, but will give better pictures.\n\n
The default is 5 pixels\n"

			);

    button[0] = MakeButton("Cancel", IntWinCancel_Button, this);
    button[1] = MakeButton("3 Pixels", IntWinSelect1, AllData);
    button[2] = MakeButton("5 Pixels", IntWinSelect2, AllData);
    button[3] = MakeButton("7 Pixels", IntWinSelect3, AllData);
  
    SetWidgetPos (button[1],
                  PLACE_UNDER, label,
                  NO_CARE, NULL);
 
    SetWidgetPos (button[2], 
		  PLACE_RIGHT, button[1], 
                  PLACE_UNDER, label);

    SetWidgetPos (button[3],
                  PLACE_RIGHT, button[2],
                  PLACE_UNDER, label);

    SetWidgetPos (button[0],
                  PLACE_UNDER, button[1],
                  NO_CARE, NULL);

    ShowDisplay();

    MainLoop();

}

//***************************************************************************  
//***************************************************************************  
IntWin::~IntWin()
{
    //close the openned window

    SetCurrentWindow(win);

    CloseWindow();
}

//***************************************************************************  
//***************************************************************************  
void IntWinCancel_Button(Widget w, void *data)
{
    // button CB to close window
    // NOTE: may also be called to remove the window by other fns

    IntWin *me = (IntWin *)data;

    delete me;
}

//***************************************************************************
//***************************************************************************
void IntWinSelect1 (Widget w, void *data)
{
    // CB to change the interpolation level

    MyProgram *AllData = (MyProgram *)data;

    AllData->mainwin.orbital.newint(3);

    IntWinCancel_Button(w, AllData->intwin);
}

//***************************************************************************
//***************************************************************************
void IntWinSelect2 (Widget w, void *data)
{
    // CB to change the interpolation level

    MyProgram *AllData = (MyProgram *)data;

    AllData->mainwin.orbital.newint(5);

    IntWinCancel_Button(w, AllData->intwin);
}

//***************************************************************************
//***************************************************************************
void IntWinSelect3 (Widget w, void *data)
{
    // CB to change the interpolation level

    MyProgram *AllData = (MyProgram *)data;

    AllData->mainwin.orbital.newint(7);

    IntWinCancel_Button(w, AllData->intwin);
}

