//*****************************************************************************
//      Header file for:
//		main program data structure
//
//      Written by Stuart Prescott:
//              Written:                21/08/1996
//              Last Modified:          27/10/1996
//
//      Libraries Required:
//              libsx (Dominic Giamapolo - Athena Widget Set)
//
//      Other Object Classes used:
//              win (base class)
//              template arrays
//              3D points / vectors / matrices
//              graphs
//              ArcBall
//		orbital selector
//              orbital drawing
//              information window
//              interpolation settings window
//              control panel
//
//*****************************************************************************
// SP 21/08/96  
  
 
#ifndef TRUE  
#define TRUE  1  
#define FALSE 0  
#endif  
  
#ifndef MAIN_CLASS_DEFINITIONS_H  
#define MAIN_CLASS_DEFINITIONS_H 1  

#include "vectors.h"
#include "arraytem.h"
#include "mathxtra.h"

#include "objects.h"
#include "h3d.h"

#include "win.h"
#include "selecto.h"
#include "panel.h"
#include "arcball.h"
#include "intwin.h"
#include "info.h"
 
#ifndef ACTIONTYPE 
#define ACTIONTYPE 1
    enum actionflagtype {WAITING_FOR_SELECTION, DRAWING_ORBITAL_DENSITY};  
#endif
  
class MenuItems  
{  
    public:  
        Widget menu;  
        Widget item[4];  
  
};    //MenuItems  
  
class  MainWin: public Win  
{  
    public:  
        //required widgets  
        Widget draw_area;  
        Widget title_area;  
  
	// hold the window height and width  
	int height, width;  
  
	Orbital 	orbital;  
	OrbitalSelect 	orbitalselect;  
  
};    //MainWin  
  
typedef struct MyProgram  
{  
    // a mode flag  
    actionflagtype mode;  
  
    // classes for the windows . . .   
    class IntWin 	*intwin;
    class InfoWin 	*infowin;  
    class ArcballWin 	*arcballwin;  
    class Panel 	*panelwin;
    class MainWin 	mainwin;  
  
};    //MyProgram  
  
// prototypes for the functions in the main program  
void init_display(int argc, char **argv, MyProgram *me);  
  
#endif  
