//*****************************************************************************
//      C++ functions for:
//		wavefunction value addon
//      Template Definitions for:
//
//      Written by Stuart Prescott:
//              Written:                05/10/1996
//              Last Modified:          27/10/1996
//
//      Libraries Required:
//              libsx (Dominic Giamapolo - Athena Widget Set)
//
//      System headers:
//              Streamed I/O
//              Formatted I/O
//
//      Other Object Classes used:
//              main program data structure
//		callback
//		orbital drawing
//
//*****************************************************************************
  
extern "C" {  
    #include <libsx.h>  
}  

#include <stdio.h>
#include <iostream.h>  

#include "psi2.h"
#include "main.h"  
#include "callback.h"  
#include "h3d.h"

#define DEBUGWFCONTROL		0

//****************************************************************************
//****************************************************************************
void wfcontrolMouseDownCB(Widget w, int which, int x, int y, void *data)
{
    MyProgram *me = (MyProgram *)data;

    switch (which)
    {
	case 1:
	{
            //Work out which graph we're in
            if (me->mainwin.orbital.view->WhichGraph(x,y))
            {
                //Set Mouse motion CB
                //(Mouse up CB only set if there is mouse motion)
	        SetMouseMotionCB(w, wfcontrolMouseMoveCB);
	        SetButtonUpCB (w, wfcontrolNoMoveCB);
	    }

	    break;
        }
	case 2:
	{
	    break;
	}
	case 3:
	{
	    me->intwin = new IntWin(me);
	    break;
	}
	
    }
    return;
}

//****************************************************************************
//****************************************************************************
void wfcontrolMouseMoveCB(Widget w, int x, int y, void *data)
{
    MyProgram *me = (MyProgram *)data;
    
    SetButtonUpCB(w, wfcontrolMouseUpCB);
    me->mainwin.orbital.view->DrawLevPix(y);

    return;
}

//****************************************************************************
//****************************************************************************
void wfcontrolMouseUpCB(Widget w, int which, int x, int y, void *data)
{
    MyProgram *me = (MyProgram *)data;

    SetMouseMotionCB  (w, NULL);
    SetButtonUpCB     (w, NULL);
    
    me->mainwin.orbital.view->DrawLevPix(y);
    Redisplay(me->mainwin.draw_area, me->mainwin.width, me->mainwin.height, me);

    return;
}

//****************************************************************************
//****************************************************************************
void wfcontrolNoMoveCB(Widget w, int which, int x, int y, void *data)
{
    SetMouseMotionCB  (w, NULL);
    SetButtonUpCB     (w, NULL);
    return;
}
